local originalBeginSession = BeginSession

-- Script by ArkaZ < arkaz@hotmail.fr >
-- Special thanks to the Phantom Mod Team for their code

local ScenarioUtils = import('/lua/sim/ScenarioUtilities.lua')


function OnPopulate()
	ScenarioUtils.InitializeArmies()
end

local numPlayers = 0
local players = {} -- players|1,numPlayers| represents the index of players 
local targets = {} -- targets|indexes of players| represents the target of a player 


function UpdateUnitProduction(armyNumber)
    local units = ArmyBrains[armyNumber]:GetListOfUnits( categories.ALLUNITS, false )
    for k,v in units do		
        local bpEcon = v:GetBlueprint().Economy	
		if bpEcon then
			v:SetProductionPerSecondMass(bpEcon.ProductionPerSecondMass) 
			v:SetProductionPerSecondEnergy(bpEcon.ProductionPerSecondEnergy)
		end
    end
end

function KYTThreadTarget()
	while true do
		WaitSeconds(120)
		armyTarget = targets[GetFocusArmy()]
		PrintText('Your current target is ' .. ArmyBrains[armyTarget].Nickname, 12, ArmyBrains[armyTarget].Color, 30, 'rightcenter')
	end
end

function KYTMainThread()

	for index, army in ArmyBrains do
		if ArmyIsCivilian(index) == false and ArmyIsOutOfGame(index) == false then			
			numPlayers = numPlayers + 1
			players[numPlayers] = index 	
			army.bonus = 1		

		end
	end

	-- Mix the player order
	for i=1,100	do 
		p1 = Random(numPlayers) 
		p2 = Random(numPlayers) 
		tmp = players[p1]
		players[p1] = players[p2]
		players[p2] = tmp
	end
	
	-- Set targets
	if numPlayers > 0 then
		targets[players[numPlayers]] = players[1] -- loop the targets
	else
		return -- Safety test
	end	
	for i=1,(numPlayers-1) do
		targets[players[i]] = players[i+1]
	end
	
	
	
	-- Make everyone enemies
	for ind1, army1 in players do
		for ind2, army2 in players do
			if ind1 ~= ind2 then -- Not ennemy to yourself
				SetAlliance(army1, army2, 'Enemy')
			end
		end
	end
	
	
	PrintText('Kill your target!', 20, nil, 10, 'leftcenter')
	WaitSeconds(2)
	
	for armyAttacker, armyTarget in targets do 
		if armyAttacker == GetFocusArmy() then
			PrintText('Your target is ' .. ArmyBrains[armyTarget].Nickname, 20, ArmyBrains[armyTarget].Color, 20, 'leftcenter')		
		end
	end
	
	while true do
		WaitSeconds(1)
		
		for ind, army in players do
			local brain = GetArmyBrain(army)			
			if brain:IsDefeated() then
				-- Change the target of the killer
				for armyAttacker, armyTarget in targets do 
					if armyTarget == army then
						targets[armyAttacker] = targets[armyTarget]
						if not GetArmyBrain(armyAttacker):IsDefeated() then
							ArmyBrains[armyAttacker].bonus = ArmyBrains[armyAttacker].bonus + 1
							UpdateUnitProduction(armyAttacker)
							if armyAttacker == GetFocusArmy()  then
								PrintText('Congratulations! You just killed your target.', 20, nil, 10, 'leftcenter')		
								if armyAttacker ~= targets[armyTarget] then
									PrintText('Your new target is ' .. ArmyBrains[targets[armyAttacker]].Nickname, 20, ArmyBrains[armyAttacker].Color, 10, 'leftcenter')
									PrintText('Your resource bonus is now x' .. ArmyBrains[armyAttacker].bonus, 20, ArmyBrains[armyAttacker].Color, 10, 'leftcenter')									
								end
							elseif armyAttacker ~= GetFocusArmy() then
								PrintText(ArmyBrains[armyAttacker].Nickname .. ' just killed his target.', 20, ArmyBrains[armyAttacker].Color, 10, 'leftcenter')
								if armyAttacker ~= targets[armyTarget] then
									PrintText('His resource bonus is now x' .. ArmyBrains[armyAttacker].bonus, 20, ArmyBrains[armyAttacker].Color, 10, 'leftcenter')	
								end
							end
						end
					end
				end								
				-- Decrease the number of alive players
				numPlayers = numPlayers - 1
				-- Remove the player from alive players
				players[ind] = nil
			end
		end
		
		if numPlayers == 1 then
			for ind, army in players do
				PrintText(ArmyBrains[army].Nickname .. ' is the last man standing!', 20, ArmyBrains[army].Color, 10, 'leftcenter')
			end
			WaitSeconds(5)
			break
		end
		if numPlayers < 1 then
			PrintText('The game ends in a draw!', 20, nil, 10, 'leftcenter')
			WaitSeconds(5)
			break
		end
	end
	
	for tmp, army in players do
		local brain = GetArmyBrain(army)
		if not brain:IsDefeated() then
			brain:OnVictory()
		end
	end

end


function OnStart()
	local KYT_main_thread = ForkThread(KYTMainThread)
	local KYT_thread_target = ForkThread(KYTThreadTarget)
end


function BeginSession()
	originalBeginSession()
	OnStart()    
end